package TowelPlacementPackage
{
  function MiniGameSO::reset(%this, %client)
  {
    Parent::reset(%this, %client);

    if (%this.owner != 0)
      return;

    %this.towelTick();
  }

  function Armor::onEnterLiquid(%this, %obj, %coverage, %type)
  {
    Parent::onEnterLiquid(%this, %obj, %coverage, %type);

    if (getMiniGameFromObject(%obj) == $DefaultMiniGame)
    {
      if (isObject(%obj.spawnBrick))
        %obj.lavaDamage(1);
      else
        %obj.checkWaterKill();
    }
  }

  function Armor::onLeaveLiquid(%this, %obj, %coverage, %type)
  {
    Parent::onLeaveLiquid(%this, %obj, %coverage, %type);

    if (isEventPending(%obj.checkWaterKill))
      cancel(%obj.checkWaterKill);
  }
};

activatePackage("TowelPlacementPackage");

function MiniGameSO::towelTick(%this, %start)
{
  cancel(%this.towelTick);

  if (%start $= "")
    %start = $Sim::Time;

  %time = $Sim::Time - %start;
  %height = %time / 2;

  setEnvironment("WaterHeight", %height);
  %this.towelTick = %this.schedule(50, towelTick, %start);
}

function Player::checkWaterKill(%this)
{
  cancel(%this.checkWaterKill);

  if (%this.getWaterCoverage() >= 0.2)
    %this.kill();

  %this.checkWaterKill = %this.schedule(100, checkWaterKill);
}